import { messageTypes } from '../../../misc';
import { ResourceManager } from '../../database/ResourceManager';
import { RAFirebaseOptions } from '../../options';
import { loggerTypes } from '../../../tools/reads-logger/utils/logger-helpers';
import { IFirebaseWrapper } from '../../database/firebase/IFirebaseWrapper';
export declare class FirebaseLazyLoadingClient {
    private readonly options;
    private readonly rm;
    private readsLogger;
    private fireWrapper;
    constructor(options: RAFirebaseOptions, rm: ResourceManager, readsLogger: loggerTypes.ReadsLogger | false, fireWrapper: IFirebaseWrapper);
    setReadsLogger(readsLogger: loggerTypes.ReadsLogger | false): void;
    apiGetList(resourceName: string, reactAdminParams: messageTypes.IParamsGetList): Promise<messageTypes.IResponseGetList>;
    apiGetManyReference(resourceName: string, reactAdminParams: messageTypes.IParamsGetManyReference): Promise<messageTypes.IResponseGetManyReference>;
    private paramsToQuery;
    private filtersToQuery;
    private sortToQuery;
    private paginationToQuery;
    private getFullParamsForQuery;
    private getNextPageParams;
    private checkIfOnLastPage;
    private setQueryCursor;
    private getQueryCursor;
    clearQueryCursors(resourceName: string): void;
    private findLastQueryCursor;
    private tryGetResource;
    incrementFirebaseReadsCounter(newReads: number): void;
}
